<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSocialNetworksName ArrayType
 * @subpackage Arrays
 */
class ArrayOfSocialNetworksName extends AbstractStructArrayBase
{
    /**
     * The SocialNetworksName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $SocialNetworksName;
    /**
     * Constructor method for ArrayOfSocialNetworksName
     * @uses ArrayOfSocialNetworksName::setSocialNetworksName()
     * @param string[] $socialNetworksName
     */
    public function __construct(array $socialNetworksName = array())
    {
        $this
            ->setSocialNetworksName($socialNetworksName);
    }
    /**
     * Get SocialNetworksName value
     * @return string[]|null
     */
    public function getSocialNetworksName()
    {
        return $this->SocialNetworksName;
    }
    /**
     * This method is responsible for validating the values passed to the setSocialNetworksName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSocialNetworksName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSocialNetworksNameForArrayConstraintsFromSetSocialNetworksName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSocialNetworksNameSocialNetworksNameItem) {
            // validation for constraint: enumeration
            if (!\EnumType\SocialNetworksName::valueIsValid($arrayOfSocialNetworksNameSocialNetworksNameItem)) {
                $invalidValues[] = is_object($arrayOfSocialNetworksNameSocialNetworksNameItem) ? get_class($arrayOfSocialNetworksNameSocialNetworksNameItem) : sprintf('%s(%s)', gettype($arrayOfSocialNetworksNameSocialNetworksNameItem), var_export($arrayOfSocialNetworksNameSocialNetworksNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SocialNetworksName', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\SocialNetworksName::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SocialNetworksName value
     * @uses \EnumType\SocialNetworksName::valueIsValid()
     * @uses \EnumType\SocialNetworksName::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $socialNetworksName
     * @return \ArrayType\ArrayOfSocialNetworksName
     */
    public function setSocialNetworksName(array $socialNetworksName = array())
    {
        // validation for constraint: array
        if ('' !== ($socialNetworksNameArrayErrorMessage = self::validateSocialNetworksNameForArrayConstraintsFromSetSocialNetworksName($socialNetworksName))) {
            throw new \InvalidArgumentException($socialNetworksNameArrayErrorMessage, __LINE__);
        }
        $this->SocialNetworksName = $socialNetworksName;
        return $this;
    }
    /**
     * Add item to SocialNetworksName value
     * @uses \EnumType\SocialNetworksName::valueIsValid()
     * @uses \EnumType\SocialNetworksName::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfSocialNetworksName
     */
    public function addToSocialNetworksName($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SocialNetworksName::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SocialNetworksName', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\SocialNetworksName::getValidValues())), __LINE__);
        }
        $this->SocialNetworksName[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\SocialNetworksName::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfSocialNetworksName
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SocialNetworksName::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SocialNetworksName', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\SocialNetworksName::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SocialNetworksName
     */
    public function getAttributeName()
    {
        return 'SocialNetworksName';
    }
}
