<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HighSeasonAndDistanceValue StructType
 * @subpackage Structs
 */
class HighSeasonAndDistanceValue extends ItemTypeValue
{
    /**
     * The highSeasonOnly
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $highSeasonOnly;
    /**
     * The distance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $distance;
    /**
     * Constructor method for HighSeasonAndDistanceValue
     * @uses HighSeasonAndDistanceValue::setHighSeasonOnly()
     * @uses HighSeasonAndDistanceValue::setDistance()
     * @param bool $highSeasonOnly
     * @param string $distance
     */
    public function __construct($highSeasonOnly = null, $distance = null)
    {
        $this
            ->setHighSeasonOnly($highSeasonOnly)
            ->setDistance($distance);
    }
    /**
     * Get highSeasonOnly value
     * @return bool
     */
    public function getHighSeasonOnly()
    {
        return $this->highSeasonOnly;
    }
    /**
     * Set highSeasonOnly value
     * @param bool $highSeasonOnly
     * @return \StructType\HighSeasonAndDistanceValue
     */
    public function setHighSeasonOnly($highSeasonOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($highSeasonOnly) && !is_bool($highSeasonOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($highSeasonOnly, true), gettype($highSeasonOnly)), __LINE__);
        }
        $this->highSeasonOnly = $highSeasonOnly;
        return $this;
    }
    /**
     * Get distance value
     * @return string|null
     */
    public function getDistance()
    {
        return $this->distance;
    }
    /**
     * Set distance value
     * @param string $distance
     * @return \StructType\HighSeasonAndDistanceValue
     */
    public function setDistance($distance = null)
    {
        // validation for constraint: string
        if (!is_null($distance) && !is_string($distance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($distance, true), gettype($distance)), __LINE__);
        }
        $this->distance = $distance;
        return $this;
    }
}
